// See the Device Info tab, or Template settings
#define BLYNK_TEMPLATE_ID "TMPL4WH76PuDa"
#define BLYNK_TEMPLATE_NAME "Air Quality Monitor"
#define BLYNK_AUTH_TOKEN "Y03ib1hQJRWQtLILgNre2f2cAIp9Bmq9"

#define BLYNK_PRINT Serial

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <TimeLib.h>
#include <WidgetRTC.h>

// WiFi credentials.
char ssid[] = "Andrei";
char pass[] = "supermisto";

#include <SoftwareSerial.h>
SoftwareSerial EspSerial(2, 3); // RX, TX

// ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

// DHT
#include <DFRobot_DHT11.h>
DFRobot_DHT11 DHT;
#define DHT11_PIN 7
float t,h;

// Air quality sensor MQ135
int MQsensorValue = 0;

// Blynk LCD
String welcome = "Welcome to AQM!";

#define BUZZER_PIN 11
#define PIN_RED 9
#define PIN_GREEN 5
#define PIN_BLUE 6

BlynkTimer timer;
WidgetRTC rtc;

void myTimer(){
  Blynk.virtualWrite(V5, MQsensorValue);
  Blynk.virtualWrite(V0, t);
  Blynk.virtualWrite(V1, h);
}

BLYNK_READ(V4)
{
  //send to app
  Blynk.virtualWrite(V4, welcome);
}

BLYNK_CONNECTED() {
  // Synchronize time on connection
  rtc.begin();
}

void setup()
{
  // Debug console
  Serial.begin(115200);
  pinMode(BUZZER_PIN, OUTPUT);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass, "blynk.cloud", 80);
  timer.setInterval(1000L, myTimer); 
  timer.setInterval(1000L, clockDisplay);
}

void clockDisplay()
{
  String currentTime = String(hour()) + ":" + minute() + ":" + second();
  String currentDate = String(day()) + " / " + month() + " / " + year();

  // Send time to the App
  Blynk.virtualWrite(V2, currentTime);
  // Send date to the App
  Blynk.virtualWrite(V3, currentDate);
}

void loop()
{
  //Air quality sensor
  MQsensorValue = analogRead(A0);

  //DHT sensor
  DHT.read(DHT11_PIN);
  h = DHT.humidity;
  t = DHT.temperature;

  Serial.println("Sent");

  Blynk.run();
  timer.run();
}
